const {ccclass, property, playOnFocus, executeInEditMode} = cc._decorator;

@ccclass
@playOnFocus
@executeInEditMode
export default class Tester extends cc.Component {

    @property({ type: cc.Prefab })
    public prefab: cc.Prefab = new cc.Prefab();

    onLoad () {
        this.initialize()
    }

    onFocusInEditor() {
        this.initialize();
    }

    onLostFocusInEditor() {
    }

    initialize() {
        if (this.node.children.length > 0 || !this.prefab) return;

        let x= 0 , y = 0;
        for (let src in cc.macro.BlendFactor) {
            for (let dest in cc.macro.BlendFactor) {

                const node = cc.instantiate(this.prefab);
                const spr = node.getComponent(cc.Sprite);
                spr.srcBlendFactor = (<any>cc.macro.BlendFactor)[src];
                spr.dstBlendFactor = (<any>cc.macro.BlendFactor)[dest];
                
                console.log(`X: ${x}, Y: ${y}, SRC: ${src}, DST: ${dest}`);

                node.setPosition(x,y);
                this.node.addChild(node);
          
                x += 32;
            }
            y -= 32;
            x = 0;
        }
    }
}
